<script setup>
import AppShare from '@/helpers/AppShare'
import { useDialogStore } from '@/stores/DialogStore';
import { useAppStore } from '@/stores/AppStore'
</script>


<script>
export default {

	data() {
		const appStore = useAppStore()
		return {
			appStore,
			icon: appStore.icon,
			type: 'revert',
			file: null,
		}
	},

	watch: {
		'appStore.icon'(current, old) {
			this.icon = current
		}
	},

	methods: {
		onUpload(e) {
			this.file = e.target.files[0]
			this.icon = URL.createObjectURL(this.file)
			this.type = 'upload'
		},

		onReset(e) {
			this.icon = '/img/default-profile-icon.png'
			this.type = 'reset'
		},

		onRevert(e) {
			this.icon = this.appStore.icon
			this.type = 'revert'
		},

		async onSubmit(e) {
			const dialogStore = useDialogStore()

			if (this.type === 'upload') {
				const formData = new FormData()
				formData.append('image', this.file, this.file.name)

				const result = await dialogStore.waitBox(async () =>
					await AppShare.client.call(`profile/icon`, {
						method: 'POST',
						headers: AppShare.client.formDataHeaders(),
						data: formData,
					})
				)
				if (!dialogStore.handleRestError(result)) {
					this.appStore.icon = this.icon
				}
			}

			else if (this.type === 'reset') {
				const result = await dialogStore.waitBox(async () =>
					await AppShare.client.call(`profile/icon`, {
						method: 'DELETE',
						headers: AppShare.client.defaultHeaders(),
					})
				)
				if (!dialogStore.handleRestError(result)) {
					this.appStore.icon = this.icon
				}
			}

			this.$router.push({ name: 'home' })
		},
	},

	i18n: {
		messages: {
			en: {
				title: "Change Icon",
				icon: "Current Icon",
				ok: "Change Icon",
			},
			th: {
				title: "เปลี่ยนรูป Icon",
				icon: "Icon ปัจจุบัน",
				ok: "เปลี่ยนรูป Icon",
			},
		},
	},
}
</script>


<template>
	<AuthenRequired>
		<AppBox :title="$t('title')">
			<form id="form" enctype="multipart/form-data" @submit.prevent="onSubmit">
				<img :width="128" :height="128" :src="icon"
					:alt="this.appStore.member ? this.appStore.member.email : ''"
					:title="this.appStore.member ? this.appStore.member.name : ''" />
				<br />

				<div>
					<button @click.prevent="onReset">{{  $t('imageChooser.reset')  }}</button>
					<button @click.prevent="onRevert">{{  $t('imageChooser.revert')  }}</button>
					<input type="file" accept="image/png, image/jpeg" @change="onUpload" />
				</div>
				<br />

				<button type="submit">{{  $t('ok')  }}</button>
			</form>
		</AppBox>
	</AuthenRequired>
</template>


<style scoped>
</style>
